Subject: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?

From: Alan Third <[email-masked]>
Date: Sat, 17 Oct 2020 16:27:58 +0100

On Sat, Oct 17, 2020 at 08:38:10AM +0200, Lars Ingebrigtsen wrote:
> Alan Third <[email-masked]> writes:
> 
> > On the other hand it comes preinstalled, it only works on Apple
> > devices, and Noto Color Emoji doesn't work on Apple devices. I'm not
> > sure we'd really be "promoting" it.
> 
> On the third hand, since it's preinstalled, Emacs doesn't need to
> mention it, because it's always there, and Emacs won't have problems
> displaying the characters it offers.

Even once I remove this code:

modified   src/macfont.m
@@ -2414,11 +2414,6 @@ So we use CTFontDescriptorCreateMatchingFontDescriptor (no
                   != (spacing >= FONT_SPACING_MONO)))
             continue;
 
-          /* Don't use a color bitmap font unless its family is
-             explicitly specified.  */
-          if ((sym_traits & kCTFontTraitColorGlyphs) && NILP (family))
-            continue;
-
           if (j > 0
               && !macfont_supports_charset_and_languages_p (desc, charset,
                                                             chars, languages))

Emacs almost never finds Apple Color Emoji without help. I've no idea
why.

For some reason it finds the font for BLACK DOWN-POINTING DOUBLE
TRIANGLE, but not SMILING FACE WITH SMILING EYES unless the former is
already in the document.

Should this Just Work?

BTW, there is code in ns-win.el that plays with the default fontset on
Macs which may be breaking our rules.
-- 
Alan Third